(function () {
    "use strict";

    angular.module('core').controller('tituloReceberController', controller);
    controller.$inject = ['$scope', '$timeout', '$q', '$stateParams', '$alert', 'faturaReceberService', 'lookupService', 'categoriaFinanceiraService'];

    function controller($scope, $timeout, $q, $stateParams, $alert, faturaReceberService, lookupService, categoriaFinanceiraService) {
        $scope.initializeLayout('Títulos a Receber');

        //[Inicializa objetos]
        $scope.state = {
            data: [],
            carregando: false,
            carregandoMais: false,
            salvando: false,
            vazio: false,
            completo: false,
            count: 0,
            filtro: {
                ativo: false,
                args: {
                    chaves: '',
                    filtro: null,
                    sortExpression: '',
                    skip: 0,
                    take: 20
                }
            },
            totais: {
                ValorOriginal: null,
                ValorEmAberto: null,
                ValorLiquidado: null,
                ValorAbatido: null,
            },
        };
        $scope.popups = {
            /* add a entidade é FaturaReceber. */
            add: {
                ativo: false,
                data: {},
                save: function (action) {
                    $scope.state.salvando = true;
                    faturaReceberService
                        .save($scope.popups.add.data)
                        .then(
                            function (response) {
                                if (response.Status < 0) {
                                    $alert({ text: response.Message, title: $scope.Title });
                                } else {
                                    $scope.popups.add.ativo = false;
                                    $scope.popups.add.data = {};
                                    $scope.refresh();

                                    if (action === $scope.popups.add.saveAction.saveAndNew) {
                                        $scope.popups.add.prepare();
                                    }
                                    else if (action === $scope.popups.add.saveAction.saveAndEdit) {
                                        $state.go("state-titulo-receber", { id: response.Data.ID });
                                    }
                                }
                                $scope.state.salvando = false;
                            },
                            function (_error) {
                                $scope.state.salvando = false;
                                $scope.tools.toastr.error('Não foi possível conectar com o(s) servidor(es)');
                            });
                },
                saveAction: { save: 0, saveAndNew: 1 },
                prepare: function () {
                    $scope.popups.add.steps.index = 0;
                    faturaReceberService
                        .prepareNew()
                        .then(
                            function (response) {
                                if (response.Status < 0) {
                                    $scope.tools.toastr.error(response.Message, 'Serviço');
                                    $scope.popups.edit.ativo = false;
                                } else {
                                    $scope.popups.add.data = response.Data;
                                    $scope.popups.add.ativo = true;
                                    $timeout(function () { $('[ng-model*="popups.add.data.Nome"]').focus(); });
                                }
                            },
                            function (_error) {
                                $scope.popups.edit.ativo = false;
                                $scope.tools.toastr.error('Não foi possível conectar com o(s) servidor(es)');
                            });
                },
                toggle: function () {
                    $scope.popups.add.ativo = !$scope.popups.add.ativo
                    if ($scope.popups.add.ativo) {
                        $scope.popups.add.prepare();
                    }
                },
                steps: {
                    index: 0,
                    count: 3,
                    next: function () {
                        if ($scope.popups.add.steps.index < ($scope.popups.add.steps.count - 1))
                            $scope.popups.add.steps.index++;
                    },
                    prior: function () {
                        if ($scope.popups.add.steps.index > 0)
                            $scope.popups.add.steps.index--;
                    },
                },
            },
            /* add a entidade é TituloReceber. */
            edit: {
                ativo: false,
                data: {},
                save: function (manterAberto) {
                    $scope.state.salvando = true;
                    faturaReceberService
                        .saveTituloReceber($scope.popups.edit.data)
                        .then(
                            function (response) {
                                if (response.Status < 0) {
                                    $alert({ title: $scope.Title, text: response.Message });
                                } else {
                                    if (!manterAberto)
                                        $scope.historyBack();
                                    else
                                        $scope.popups.edit.data = response.Data;
                                }
                                $scope.state.salvando = false;
                            },
                            function (_error) {
                                $scope.state.salvando = false;
                                $scope.tools.toastr.error('Não foi possível conectar com o(s) servidor(es)');
                            });
                },
                get: function (id) {
                    $scope.state.salvando = true;
                    faturaReceberService
                        .getTituloReceber(id)
                        .then(
                            function (response) {
                                if (response.Status < 0) {
                                    $alert({ title: $scope.Title, text: response.Message });
                                    $scope.popups.edit.ativo = false;
                                } else {
                                    $scope.popups.edit.data = response.Data;
                                    $scope.popups.edit.ativo = true;
                                }
                                $scope.state.salvando = false;
                            },
                            function (_error) {
                                $scope.state.salvando = false;
                                $scope.tools.toastr.error('Não foi possível conectar com o(s) servidor(es)');
                            });
                },
                prepare: function (item) {
                    $scope.state.salvando = true;
                    faturaReceberService
                        .prepareTituloReceber($scope.popups.edit.data)
                        .then(
                            function (response) {
                                if (response.Status < 0) {
                                    $alert({ title: $scope.Title, text: response.Message });
                                    $scope.popups.edit.ativo = false;
                                } else {
                                    $scope.popups.edit.data = response.Data;
                                    $scope.popups.edit.ativo = true;
                                }
                                $scope.state.salvando = false;
                            },
                            function (_error) {
                                $scope.state.salvando = false;
                                $scope.tools.toastr.error('Não foi possível conectar com o(s) servidor(es)');
                            });
                },
                prepareNewLiquidacao: function () {
                    faturaReceberService
                        .prepareNewLiquidacaoTituloReceber($scope.popups.edit.data)
                        .then(
                            function (response) {
                                if (response.Status < 0) {
                                    $alert({ title: $scope.Title, text: response.Message });
                                } else {
                                    $scope.popups.edit.data = response.Data;
                                    $scope.popups.liquidacao.select($scope.popups.edit.data.Liquidacoes.length - 1);
                                }
                            },
                            function (_error) {
                                $scope.tools.toastr.error('Não foi possível conectar com o(s) servidor(es)');
                            });
                },
                delete: function () {
                    $scope.state.salvando = true;
                    faturaReceberService
                        .deleteTituloReceber($scope.popups.edit.data.ID)
                        .then(
                            function (response) {
                                if (response.Status < 0) {
                                    $alert({ title: $scope.Title, text: response.Message });
                                } else {
                                    $scope.popups.edit.ativo = false;
                                    $scope.historyBack();
                                }
                                $scope.state.salvando = false;
                            },
                            function (_error) {
                                $scope.state.salvando = false;
                                $scope.tools.toastr.error('Não foi possível conectar com o(s) servidor(es)');
                            });
                },
                toggle: function (id) {
                    $scope.popups.edit.ativo = !$scope.popups.edit.ativo
                    if ($scope.popups.edit.ativo && id) {
                        $scope.popups.edit.get(id);
                    }
                },
            },
            /* a entidade é LiquidacaoTituloReceber */
            liquidacao: {
                index: -1,
                data: null,
                select: function (index) {
                    $scope.popups.liquidacao.index = index;
                    $scope.popups.liquidacao.data = $scope.popups.edit.data.Liquidacoes[index];

                    $timeout(function () { $('[ng-model*="popups.liquidacao.data.Data"]').focus(); });
                },
                toggle: function () {
                    if ($scope.popups.liquidacao.index < 0) {
                        $scope.popups.liquidacao.index = 0;
                        $scope.popups.liquidacao.data = $scope.popups.edit.data.Liquidacoes[$scope.popups.liquidacao.index];
                    } else {
                        $scope.popups.edit.prepare();
                        $scope.popups.liquidacao.index = -1;
                        $scope.popups.liquidacao.data = null;
                    }
                },
                next: function () {
                    if ($scope.popups.liquidacao.index < $scope.popups.edit.data.Liquidacoes.length - 1) {
                        $scope.popups.liquidacao.index++;
                        $scope.popups.liquidacao.data = $scope.popups.edit.data.Liquidacoes[$scope.popups.liquidacao.index];
                    }
                },
                prior: function () {
                    if ($scope.popups.liquidacao.index > 0)
                        $scope.popups.liquidacao.index--;

                    $scope.popups.liquidacao.data = $scope.popups.edit.data.Liquidacoes[$scope.popups.liquidacao.index];
                },
            },
        };
        $scope.auxiliar = {
            competencia: {
                lookup: function (chaves) {
                    return $q.when(
                        lookupService
                            .getAllCompetencia({ chaves: chaves })
                            .then(function (response) {
                                if (response.Status < 0)
                                    $scope.tools.toastr.error(response.Message, "Serviço");
                                else
                                    return response.Data;
                            })
                    );
                },
            },
            filial: {
                lookup: function (chaves) {
                    return $q.when(
                        lookupService
                            .getAllFilial({ chaves: chaves })
                            .then(function (response) {
                                if (response.Status < 0)
                                    $scope.tools.toastr.error(response.Message, "Serviço");
                                else
                                    return response.Data;
                            })
                    );
                },
            },
            cliente: {
                lookup: function (chaves) {
                    return $q.when(
                        lookupService
                            .getAllContato({ chaves: chaves,})
                            .then(function (response) {
                                if (response.Status < 0)
                                    $scope.tools.toastr.error(response.Message, "Serviço");
                                else
                                    return response.Data;
                            })
                    );
                },
            },
            categoriaFinanceira: {
                lookup: function (chaves) {
                    return $q.when(
                        lookupService
                            .getAllCategoriaFinanceira({ chaves: chaves })
                            .then(function (response) {
                                if (response.Status < 0)
                                    $scope.tools.toastr.error(response.Message, "Serviço");
                                else
                                    return response.Data;
                            })
                    );
                },
                data: [],
                selecionada: null,
                carregando: false,
                getAll: async () => {
                    $scope.auxiliar.categoriaFinanceira.carregando = true;
                    const args = { filtro: { IndicaAnalitica: false } };
                    try {
                        const response = await categoriaFinanceiraService.getAll(args);
                        if (response.Status < 0) {
                            $alert({ text: response.Message, title: $scope.Title });
                        } else {
                            angular.copy(angular.fromJson(response.Data), $scope.auxiliar.categoriaFinanceira.data);
                            $scope.auxiliar.subcategoriaFinanceira.getAll();
                        }

                    } catch (error) {
                        $scope.tools.toastr.error('Não foi possível conectar com o(s) servidor(es)');
                        console.error(error);
                    } finally {
                        $scope.auxiliar.categoriaFinanceira.carregando = false;
                    }
                }
            },
            subcategoriaFinanceira: {
                lookup: function (chaves) {
                    var filtro = { CategoriaSuperior: { ID: null } };
                    if ($scope.popups.add.ativo && $scope.popups.add.data.Sugestao.Categoria) {
                        filtro.CategoriaSuperior.ID = $scope.popups.add.data.Sugestao.Categoria.ID;
                    }
                    if ($scope.popups.edit.ativo && $scope.popups.add.data.Categoria) {
                        filtro.CategoriaSuperior.ID = $scope.popups.edit.data.Categoria.ID;
                    }
                    return $q.when(
                        lookupService
                            .getAllSubcategoriaFinanceira({ chaves: chaves, filtro: filtro })
                            .then(function (response) {
                                if (response.Status < 0)
                                    $scope.tools.toastr.error(response.Message, "Serviço");
                                else
                                    return response.Data;
                            })
                    );
                },
                data: [],
                carregando: false,
                getAll: async () => {
                    if (!$scope.state.filtro.args.filtro?.Categoria)
                        return;

                    $scope.auxiliar.subcategoriaFinanceira.carregando = true;

                    const args = {
                        filtro: {
                            IndicaAnalitica: true,
                            Categoria: { ID: $scope.state.filtro.args.filtro.Categoria.ID }
                        }
                    };


                    try {
                        const response = await categoriaFinanceiraService.getAll(args);
                        if (response.Status < 0) {
                            $alert({ text: response.Message, title: $scope.Title });
                        } else {
                            angular.copy(angular.fromJson(response.Data), $scope.auxiliar.subcategoriaFinanceira.data);
                            $scope.auxiliar.subcategoriaFinanceira.getAll();
                        }

                    } catch (error) {
                        $scope.tools.toastr.error('Não foi possível conectar com o(s) servidor(es)');
                        console.error(error);
                    } finally {
                        $scope.auxiliar.subcategoriaFinanceira.carregando = false;
                    }
                }
            },
            contaAnalitica: {
                lookup: function (chaves) {
                    return $q.when(
                        lookupService
                            .getAllContaAnalitica({ chaves: chaves })
                            .then(function (response) {
                                if (response.Status < 0)
                                    $scope.tools.toastr.error(response.Message, "Serviço");
                                else
                                    return response.Data;
                            })
                    );
                },
            },
            contaCorrente: {
                lookup: function (chaves) {
                    return $q.when(
                        lookupService
                            .getAllContaContabil({ chaves: chaves })
                            .then(function (response) {
                                if (response.Status < 0)
                                    $scope.tools.toastr.error(response.Message, "Serviço");
                                else
                                    return response.Data;
                            })
                    );
                },
            },
            rateioCentroCusto: {
                lookup: function (chaves) {
                    return $q.when(
                        lookupService
                            .getAllRateioCentroCusto({ chaves: chaves })
                            .then(function (response) {
                                if (response.Status < 0)
                                    $scope.tools.toastr.error(response.Message, "Serviço");
                                else
                                    return response.Data;
                            })
                    );
                },
            },
            situacao: {
                indicaVencido: function (item) {
                    return new Date(item.Vencimento) < $scope.tools.date.hoje && item.ValorEmAberto > 0;
                },
                indicaAVencer: function (item) {
                    return new Date(item.Vencimento) >= $scope.tools.date.hoje && item.ValorEmAberto > 0;
                },
                indicaLiquidado: function (item) {
                    if ($scope.auxiliar.situacao.indicaVencido(item))
                        return false;

                    return item.ValorLiquidado > 0;
                },
                indicaAbatido: function (item) {
                    if ($scope.auxiliar.situacao.indicaVencido(item))
                        return false;

                    return item.ValorAbatido > 0;
                }
            },
        };
        $scope.presets = {
            EmAtraso: function () {
                $scope.state.filtro.args.filtro.UltimoAcompanhamento.IndicaConcluido = false;
                $scope.state.filtro.args.filtroAte.UltimoAcompanhamento.Previsao.TerminoEm = new Date($scope.tools.date.hoje.setSeconds($scope.tools.date.hoje.getSeconds() - 1));
            },
            AberturaHoje: function () {
                $scope.state.filtro.args.filtroDe.CriadoEm = $scope.tools.date.hoje;
                $scope.state.filtro.args.filtroAte.CriadoEm = new Date($scope.tools.date.hoje.setHours(23, 59, 59));
            },
            InicioHoje: function () {
                $scope.state.filtro.args.filtroDe.UltimoAcompanhamento.Previsao.InicioEm = $scope.tools.date.hoje;
                $scope.state.filtro.args.filtroAte.UltimoAcompanhamento.Previsao.InicioEm = new Date($scope.tools.date.hoje.setHours(23, 59, 59));
            },
            TerminoHoje: function () {
                $scope.state.filtro.args.filtroDe.UltimoAcompanhamento.Previsao.TerminoEm = $scope.tools.date.hoje;
                $scope.state.filtro.args.filtroAte.UltimoAcompanhamento.Previsao.TerminoEm = new Date($scope.tools.date.hoje.setHours(23, 59, 59));
            }
        };

        //[Inicializa funcões]
        $scope.initialize = async () => {
            await $scope.clearFilter();

            const _filtro = $scope.localStorage.getItem('state.filtro.args');
            if (_filtro) {
                await angular.copy(_filtro, $scope.state.filtro.args);
            }

            if ($stateParams.id)
                $scope.popups.edit.toggle($stateParams.id);

            $scope.refresh();
        };

        $scope.beforeRefresh = async () => {
            await $scope.convertFilter();
        };
        $scope.afterRefresh = async () => {
            /* trata mudanças no filtro */
            $scope.state.filtro.original.sortExpression = $scope.state.filtro.args.sortExpression;
            $scope.state.filtro.original.skip = $scope.state.filtro.args.skip;
            $scope.state.filtro.original.take = $scope.state.filtro.args.take;

            $scope.state.filtro.hasChanges = (angular.toJson($scope.state.filtro.original) !== angular.toJson($scope.state.filtro.args));

            /* armazena na localstorage para quando inicializar a página */
            $scope.localStorage.setItem('state.filtro.args', $scope.state.filtro.args);
        };
        $scope.refresh = async () => {
            try {
                await $scope.beforeRefresh();
                $scope.state.filtro.ativo = false;
                await $scope.innerRefresh();
                await $scope.afterRefresh();
            }
            catch (error) {
                console.error(error);
                $scope.clearFilter();
            } finally {
                $scope.$digest();
            }
        };
        $scope.clear = async () => {
            await $scope.clearFilter();
            $scope.refresh();
        };

        $scope.toggleFilter = async () => {
            $scope.state.filtro.ativo = !$scope.state.filtro.ativo;
        };
        $scope.convertFilter = async () => {
            /* prepara o filtro. Ex: in list de status */
        };
        $scope.clearFilter = async () => {
            $scope.state.filtro = {
                args: {
                    chaves: '',
                    filtro: null,
                    filtroDe: {
                        Vencimento: $scope.tools.date.getNMesesAtras(6)
                    },
                    filtroAte: {
                        Vencimento: $scope.tools.date.hoje
                    },
                    sortExpression: '[Vencimento] desc, [Codigo]',
                    skip: 0,
                    take: 20
                },
                original: {},
                hasChanges: false
            };

            await $scope.convertFilter();
            await angular.copy($scope.state.filtro.args, $scope.state.filtro.original);
        };

        $scope.innerRefresh = async () => {
            await $scope.auxiliar.categoriaFinanceira.getAll();

            await $scope.getAll();
            await $scope.count();
            await $scope.totalize();
        };
        $scope.getAll = async () => {
            try {
                $scope.state.filtro.args.skip = 0;
                $scope.state.carregando = true;
                $scope.state.vazio = false;

                let response = await faturaReceberService.getAllTituloReceber($scope.state.filtro.args)
                if (response.Status < 0) {
                    $scope.tools.toastr.error(response.Message, 'Serviço');
                } else {
                    angular.copy(angular.fromJson(response.Data), $scope.state.data);
                }
                $scope.state.vazio = ($scope.state.data == 0);
            }
            catch (error) {
                $scope.tools.toastr.error('Não foi possível conectar com o(s) servidor(es)');
            }
            finally {
                $scope.state.carregando = false;
                $scope.$apply();
            }
        };
        $scope.count = async () => {
            try {
                let response = await faturaReceberService.countTituloReceber($scope.state.filtro.args)
                if (response.Status < 0) {
                    $scope.tools.toastr.error(response.Message, 'Serviço');
                } else {
                    $scope.state.count = response.Data;
                }
            } catch (error) {
                $scope.tools.toastr.error('Não foi possível conectar com o(s) servidor(es)');
            } finally {
                $scope.$apply();
            }
        };
        $scope.getMore = async () => {
            if (!$scope.state.carregandoMais && !$scope.state.carregando && !$scope.state.completo && !($scope.state.data == 0)) {
                try {
                    $scope.state.carregandoMais = true;
                    $scope.state.filtro.args.skip += $scope.state.filtro.args.take;

                    let response = await faturaReceberService.getAllTituloReceber($scope.state.filtro.args);
                    if (response.Status < 0) {
                        $scope.tools.toastr.error(response.Message, 'Serviço');
                    } else {
                        $scope.state.data = $scope.state.data.concat(response.Data);
                    }
                } catch (error) {
                    $scope.tools.toastr.error('Não foi possível conectar com o(s) servidor(es)');
                } finally {
                    $scope.state.carregandoMais = false;
                    $scope.$apply();
                }
            }
        };
        $scope.totalize = async () => {
            try {
                let response = await faturaReceberService.totalizeTituloReceber($scope.state.filtro.args)
                if (response.Status < 0) {
                    $scope.tools.toastr.error(response.Message, 'Serviço');
                } else {
                    $scope.state.totais = response.Data;
                }
                $scope.state.vazio = ($scope.state.data == 0);
            } catch (error) {
                $scope.tools.toastr.error('Não foi possível conectar com o(s) servidor(es)');
            } finally {
                $scope.$apply();
            }
        };

        /*Inicializa funções*/
        $scope.initialize();

    }

})();